/*All ADuC706x library code provided by ADI, including this file, is provided
	as is without warranty of any kind, either expressed or implied.
 	You assume any and all risk from the use of this code.  It is the
 	responsibility of the person integrating this code into an application
 	to ensure that the resulting application performs as required and is safe.

Status:			Alpha tested.
Tools:			Developed using Keil uV3 version 3.53.
Hardware:		ADuC7060.
Description:	Example using function library.
Responsibility:
	Group:		IAC Software.
	Person:		Eckart Hartmann.
Modifications:
	2008/02/18	Design Start.
*/
#include	"ADuC7060.h"
#include	"math.h"
#include	"stdio.h"
#include	"..\LibRV\Adc\LibADC706x.h"
#include	"..\LibRV\Dac\LibDAC706x.h"
#include	"..\LibRV\Urt\LibUrt706x.h"
#include    "..\LibRV\T\LibTim706x.h"
#include    "..\LibRV\Fee\LibFee706x.h"
#include    "..\LibRV\Clk\LibClk706x.h"

#pragma import(__use_no_semihosting_swi)
//#define	uint	unsigned int

void Delay(unsigned int uLength);
void FeeTest(const int *pi3, const char pc2[]);
void TSet(void);
void CapTest(double d1);

int main(void)
    {
    int     b = 1;		//For main endless loop.
    int    	i1,i2;		//Temporary variables.
	static const int i3 = 0x12345678;	//For FeeTest();
	static const char	pc2[15000] = "Hello";
	int     iAve;		//Filtered version of iMain.
    int     iMain;		//Main ADC value.
	int		iAux;		//Aux ADC value.
	int		iGain;		//Gain setting.
	int		iStatus;	//Status of ADCs.
	double	d1,d2;		//Values to print.

    while(!(GP2DAT&2))		b = ADC1GN;		//Emergency loop.
	FeeTest(&i3,&pc2[0]);
	i1 = ClkSta(0);
	i1 = ClkPow(1,PUP_ALL,UART_ON);
	UrtCfg(0,URT_96,URT_68|URT_78);
    Delay(100);
    printf("%s %8x %8x\n\r",pc2,ADC0GN,i3);
	DacCfg(0,DAC_RINT,DAC_ON);
	for(i1=0; i1<256; i1++) for(i2=0; i2<256; i2++) DacOut(0,(i1*256+i2)<<13);
	AdcFlt(127,0,FLT_NOTCH2|FLT_RAVG2|FLT_CHOP);
	AdcGo(3,ADC_CONT,ADC_NORMAL,0);
	TSet();

    while(b)
        {
		iGain = AdcAdj(iStatus = AdcRd(&iMain,&iAux));
		DacOut(0,iMain);
		if(UrtSta()&1)
			{
			UrtWr(i2 = UrtRd());
			ADC0CON = 0x8000+(i2&7);
			}
		TMod(0,(d1>0.2),T_BIN);
		iAve = iAve-iAve/16+iMain/16;
		d1 = 1.2*iMain/0x10000000;
		d2 = 1.2*iAve/0x10000000;
		CapTest(d1);
		AdcIex((int)(d1*1000),IEX_0ON|IEX_1ON,IEX_0ALT);
//		printf("Val0=%08x Cap0=%08x ",TGo(0,0,T_RD),TCap(0,IREAD));
//		printf("Val3=%08x ",TGo(3,0,T_RD));
		printf("ADC0=% 11.9f Ave= % 11.9f Raw= %08x\n\r",d1,d2,iMain);
//        printf("ADC1=%08x % 11.9f % 8x\n\r",iAux,1.2*iAux/0x10000000,iStatus);
		TClr(0);
		TClr(1);
		TClr(2);
		TClr(3);
		}
    return 0;
    }

